CREATE OR REPLACE
PROCEDURE CALCULA_PRESCRICAO(
   P_CDFILIAL     IN SERVINTE.CDFILIAL%TYPE,
   P_CDSERVFILI   IN VARCHAR2,
   P_DTSERVINTE   IN SERVINTE.DTSERVINTE%TYPE,
   P_CDOPERADOR   IN SERVINTE.CDNUTRICIO%TYPE,
   P_CDANDAR      IN VARCHAR2,
   P_CDALA        IN VARCHAR2,
   P_CDLEITO      IN VARCHAR2,
   P_ACRES_SOBR             VARCHAR,
   P_CONFIG_ANTERIOR VARCHAR)
AS
   V_CDDIETA       DIETPADR.CDDIETPAD%TYPE;
   V_COUNTCARDAPIO NUMBER;
   V_SERVPADRAO    INTERNAC.CDSERPADDIE%TYPE;
   V_NRSEQUSERV    SERVINTE.NRSEQUSERV%TYPE;
   V_IDOPCAO       CONFCARD.IDOPCCNFCARD%TYPE;
   V_DESCCONF      CONFESCO.IDESCOCONF%TYPE;
   V_CONSIDERA     VARCHAR2(1) := '0';
   V_DTATUAL       DATE;
   V_CONST_N       VARCHAR2(1) := 'N';
   V_CONST_S       VARCHAR2(1) := 'S';
   V_UNDERLINE     VARCHAR2(1) := '_';
   V_CONST_ZERO    VARCHAR2(1) := '0';
   V_IDTPSERVHOSP_UM   VARCHAR2(1) := '1';
   V_IDTPSERVHOSP_DOIS VARCHAR2(1) := '2';
   V_HRINICSERV    VARCHAR2(4) :='2401';
   V_NUMBER_CONST_ZERO NUMBER := 0;
   V_IDESCOCONF VARCHAR2(1);
   V_DSOBSCONF VARCHAR2(250);
   V_USEDIETGROUP VARCHAR(1) :='N';
BEGIN
   SELECT SYSDATE INTO V_DTATUAL
   FROM PARAMGERAL;
   IF (P_DTSERVINTE > V_DTATUAL) THEN
      V_CONSIDERA := NULL;
   END IF;
   FOR C_PRESCRICAO IN (
      SELECT INTERNAC.CDPACIENTE, INTERNAC.DTINTERNA , INTERNAC.CDSERPADDIE,
             INTERNAC.CDLEITO   , PRESDIET.DTPRESDIET, DECODE(SERVICO.IDTIPOSERV,V_CONST_N,NULL,PRESDIET.CDDIETPAD) AS CDDIETPAD,
             DIETSERV.CDSERVFILI, SERVICO.IDTIPOSERV, PRESDIET.CDDIETPAD AS PRES_CDDIETPAD,
             NVL(DIETPADR.CDDIETGRUP, PRESDIET.CDDIETPAD) AS CDDIETGRUP, DIETPADR.IDFORMDIET,
             PRESDIET.DSPRESDIET
      FROM DIETSERV, SERVICO, DIETPADR, LEITO, INTERNAC, PRESDIET
      WHERE (PRESDIET.CDPACIENTE  = INTERNAC.CDPACIENTE)                                        AND
            (PRESDIET.CDFILIAL    = INTERNAC.CDFILIAL)                                          AND
            (PRESDIET.CDDIETPAD   = DIETSERV.CDDIETPAD)                                         AND
            (PRESDIET.CDFILIAL    = P_CDFILIAL)                                                 AND
            (DIETSERV.CDFILIAL    = P_CDFILIAL)                                                 AND
            ((INSTR(P_CDSERVFILI, V_UNDERLINE||DIETSERV.CDSERVFILI||V_UNDERLINE) <> V_NUMBER_CONST_ZERO) OR P_CDSERVFILI IS NULL) AND
            ((INSTR(P_CDALA, V_UNDERLINE||LEITO.CDALA||V_UNDERLINE) <> V_NUMBER_CONST_ZERO) OR P_CDALA IS NULL)                   AND
            ((INSTR(P_CDANDAR, V_UNDERLINE||LEITO.CDANDAR||V_UNDERLINE) <> V_NUMBER_CONST_ZERO) OR P_CDANDAR IS NULL)             AND
            ((INSTR(P_CDLEITO, V_UNDERLINE||LEITO.CDLEITO||V_UNDERLINE) <> V_NUMBER_CONST_ZERO) OR P_CDLEITO IS NULL )            AND
            (PRESDIET.DTPRESDIET  = (SELECT MAX(DTPRESDIET)
                                     FROM PRESDIET P
                                     WHERE (P.CDPACIENTE = INTERNAC.CDPACIENTE) AND
                                           (P.CDFILIAL   = INTERNAC.CDFILIAL)   AND
                                           (TO_DATE(P.DTPRESDIET) <= P_DTSERVINTE)))            AND
            ((NVL(SERVICO.HRINICSERV, V_HRINICSERV) >= TO_CHAR(SYSDATE, 'HH24MI')) OR (P_DTSERVINTE > SYSDATE))  AND
            (SERVICO.CDFILIAL     = DIETSERV.CDFILIAL)                                          AND
            (SERVICO.CDSERVFILI   = DIETSERV.CDSERVFILI)                                        AND
            (SERVICO.IDTPSERVHOSP IS NULL OR IDTPSERVHOSP NOT IN(V_IDTPSERVHOSP_UM, V_IDTPSERVHOSP_DOIS))  AND
            (INTERNAC.DTALTA IS NULL)                                                           AND
            (LEITO.CDFILIAL = INTERNAC.CDFILIAL)                                                AND
            (LEITO.CDLEITO  = INTERNAC.CDLEITO)                                                 AND
            (DIETPADR.CDDIETPAD   = PRESDIET.CDDIETPAD) ) LOOP
      BEGIN
        SELECT CDSERPADDIE INTO V_SERVPADRAO
        FROM SERVICO
        WHERE (CDFILIAL   = P_CDFILIAL) AND
              (CDSERVFILI = C_PRESCRICAO.CDSERVFILI);
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
            NULL;
      END;
      IF (V_SERVPADRAO IS NULL) OR (V_SERVPADRAO = C_PRESCRICAO.CDSERPADDIE) THEN
           SELECT COUNT(*) INTO V_COUNTCARDAPIO
           FROM CARDADIA, COMPCARD
           WHERE (CARDADIA.CDFILIAL   = P_CDFILIAL)              AND
                 (CARDADIA.CDSERVFILI = C_PRESCRICAO.CDSERVFILI) AND
                 (CARDADIA.CDDIETPAD  = C_PRESCRICAO.CDDIETPAD)  AND
                 (CARDADIA.DTCARDAPIO = P_DTSERVINTE)            AND
                 (COMPCARD.CDFILIAL   = CARDADIA.CDFILIAL)       AND
                 (COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO);
         V_CDDIETA := C_PRESCRICAO.CDDIETPAD;
         IF (V_COUNTCARDAPIO = V_NUMBER_CONST_ZERO) THEN
            IF (C_PRESCRICAO.IDTIPOSERV = V_CONST_N) THEN
               V_CDDIETA := NULL;
               V_USEDIETGROUP:=V_CONST_N;
            ELSE
               V_CDDIETA := C_PRESCRICAO.CDDIETGRUP;
               V_USEDIETGROUP:=V_CONST_S;
            END IF;
         END IF;
         SELECT LPAD((NVL(MAX(NRSEQUSERV), 0) + 1), 2, V_CONST_ZERO) INTO V_NRSEQUSERV
         FROM SERVINTE
         WHERE (CDFILIAL   = P_CDFILIAL)              AND
               (CDPACIENTE = C_PRESCRICAO.CDPACIENTE) AND
               (DTSERVINTE = P_DTSERVINTE);
         SELECT COUNT(*) INTO V_COUNTCARDAPIO
         FROM CARDADIA, COMPCARD
         WHERE (CARDADIA.CDFILIAL   = P_CDFILIAL)              AND
               (CARDADIA.CDSERVFILI = C_PRESCRICAO.CDSERVFILI) AND
               (CARDADIA.CDDIETPAD  = V_CDDIETA OR V_CDDIETA IS NULL)  AND
               (CARDADIA.DTCARDAPIO = P_DTSERVINTE)            AND
               (COMPCARD.CDFILIAL   = CARDADIA.CDFILIAL)       AND
               (COMPCARD.NRCARDAPIO = CARDADIA.NRCARDAPIO);
         IF (C_PRESCRICAO.IDFORMDIET = V_CONST_ZERO) AND (V_COUNTCARDAPIO <> V_NUMBER_CONST_ZERO) THEN
            IF (C_PRESCRICAO.IDTIPOSERV = V_CONST_N) THEN
               V_CDDIETA := C_PRESCRICAO.PRES_CDDIETPAD;
            ELSE
               V_CDDIETA := C_PRESCRICAO.CDDIETPAD;
            END IF;

            IF (V_USEDIETGROUP = V_CONST_S) THEN
               V_CDDIETA := C_PRESCRICAO.CDDIETGRUP;
            END IF;

            INSERT INTO SERVINTE
               (CDPACIENTE,  DTSERVINTE, NRSEQUSERV, DTINTERNA,
                CDFILIAL,   CDSERVFILI, CDDIETPAD, STPACIACOM,
                IDIMPRSERV,  CDNUTRICIO, CDDIETGRUPSI, DSSERVINTE)
            VALUES
               (C_PRESCRICAO.CDPACIENTE,  P_DTSERVINTE, V_NRSEQUSERV, C_PRESCRICAO.DTINTERNA,
                P_CDFILIAL,   C_PRESCRICAO.CDSERVFILI, C_PRESCRICAO.PRES_CDDIETPAD, V_CONST_ZERO,
                V_CONST_S, P_CDOPERADOR, C_PRESCRICAO.CDDIETGRUP, C_PRESCRICAO.DSPRESDIET);
            FOR C_COMPCARD IN (
               SELECT COMPCARD.CDFILAUXPRAT, COMPCARD.CDPRATO,
                      COMPCARD.CDTIPOPRAT,   COMPCARD.NRORDPRATCAR,
                      CNFCAMES.IDOPCCNFMES
               FROM CNFCAMES, CARDADIA, COMPCARD
               WHERE (CARDADIA.CDFILIAL     = P_CDFILIAL)              AND
                     (CARDADIA.CDSERVFILI   = C_PRESCRICAO.CDSERVFILI) AND
                     (CARDADIA.CDDIETPAD    = V_CDDIETA OR CARDADIA.CDDIETPAD IS NULL )AND
                     (CARDADIA.DTCARDAPIO   = P_DTSERVINTE)            AND
                     (COMPCARD.CDFILIAL     = CARDADIA.CDFILIAL)       AND
                     (COMPCARD.NRCARDAPIO   = CARDADIA.NRCARDAPIO)     AND
                     (CNFCAMES.DTREFECNFMES = CARDADIA.DTMESCARD)      AND
                     (CNFCAMES.CDSERVFILI   = CARDADIA.CDSERVFILI)     AND
                     (CNFCAMES.CDFILIAL     = CARDADIA.CDFILIAL)       AND
                     (CNFCAMES.NRSEQCNFMES  = COMPCARD.NRSEQPRATCAR)) LOOP
                 IF C_COMPCARD.IDOPCCNFMES = V_CONST_S THEN
                    V_DESCCONF := V_CONST_N;
                 ELSE
                    V_DESCCONF := V_CONST_S;
                 END IF;
                 IF (P_CONFIG_ANTERIOR = V_CONST_S) THEN
                    BEGIN
                      SELECT
                         IDESCOCONF, DSOBSCONF INTO V_IDESCOCONF, V_DSOBSCONF
                      FROM
                         CONFESCO CF
                      WHERE
                         (CF.CDFILIAL = P_CDFILIAL)                 AND
                         (CF.CDPACIENTE = C_PRESCRICAO.CDPACIENTE)  AND
                         (CF.DTSERVINTE = P_DTSERVINTE)             AND
                         (CF.CDTIPOPRAT = C_COMPCARD.CDTIPOPRAT)    AND
                         (CF.CDSEQUCOPR = LPAD(C_COMPCARD.NRORDPRATCAR, 4,V_CONST_ZERO)) AND
                         (CF.NRSEQUSERV = (SELECT MAX(TO_NUMBER(SERVINTE.NRSEQUSERV))
                                           FROM SERVINTE
                                           WHERE
                                             (SERVINTE.CDFILIAL = CF.CDFILIAL    ) AND
                                             (SERVINTE.DTSERVINTE = CF.DTSERVINTE) AND
                                             (SERVINTE.CDPACIENTE = CF.CDPACIENTE) AND
                                             (TO_NUMBER(SERVINTE.NRSEQUSERV)<(TO_NUMBER(V_NRSEQUSERV))) AND
                                             (SERVINTE.CDSERVFILI = C_PRESCRICAO.CDSERVFILI)
                                          ));
                    EXCEPTION
                       WHEN NO_DATA_FOUND THEN
                       BEGIN
                          V_IDESCOCONF := V_DESCCONF;
                          V_DSOBSCONF  := NULL;
                       END;
                    END;
                 END IF;

                 INSERT INTO CONFESCO
                    (CDFILIAL, CDPACIENTE, DTSERVINTE, NRSEQUSERV,
                     CDSEQUCOPR, IDOPCAOCONF,
                     IDESCOCONF, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT, DSOBSCONF)
                 VALUES
                    (P_CDFILIAL, C_PRESCRICAO.CDPACIENTE, P_DTSERVINTE, V_NRSEQUSERV,
                     LPAD(C_COMPCARD.NRORDPRATCAR, 4,V_CONST_ZERO),
                     C_COMPCARD.IDOPCCNFMES,DECODE(P_CONFIG_ANTERIOR,V_CONST_S,V_IDESCOCONF, V_DESCCONF),
                     C_COMPCARD.CDFILAUXPRAT, C_COMPCARD.CDPRATO, C_COMPCARD.CDTIPOPRAT,
                     DECODE(P_CONFIG_ANTERIOR,V_CONST_S,V_DSOBSCONF,NULL));

                 V_IDESCOCONF := NULL;
                 V_DSOBSCONF  := NULL;
            END LOOP;
            /*DELETE TODAS AS DIETAS ORAIS DESTE SERVIO DO PACIENTE SE A OPO SOBREPOR FOI MARCADA (menos a que foi includa agora)*/
           IF (P_ACRES_SOBR = V_CONST_S) THEN

              DELETE FROM CONFESCO
              WHERE
                 (CONFESCO.CDFILIAL = P_CDFILIAL) AND
                 (CONFESCO.CDPACIENTE = C_PRESCRICAO.CDPACIENTE) AND
                 (CONFESCO.DTSERVINTE = P_DTSERVINTE)            AND
                 (CONFESCO.NRSEQUSERV IN (SELECT SERVINTE.NRSEQUSERV
                                        FROM SERVINTE
                                        WHERE
                                        (SERVINTE.CDPACIENTE = C_PRESCRICAO.CDPACIENTE) AND
                                        (SERVINTE.CDFILIAL = P_CDFILIAL)                AND
                                        (SERVINTE.STPACIACOM = V_CONST_ZERO)            AND
                                        (SERVINTE.IDIMPRSERV = V_CONST_S)               AND
                                        (SERVINTE.DTSERVINTE = P_DTSERVINTE)            AND
                                        (SERVINTE.NRSEQUSERV <> V_NRSEQUSERV)           AND
                                        (SERVINTE.CDSERVFILI = C_PRESCRICAO.CDSERVFILI)));
              DELETE FROM SERVINTE
              WHERE
                 (SERVINTE.CDPACIENTE = C_PRESCRICAO.CDPACIENTE) AND
                 (SERVINTE.CDFILIAL = P_CDFILIAL)                AND
                 (SERVINTE.STPACIACOM = V_CONST_ZERO)            AND
                 (SERVINTE.IDIMPRSERV = V_CONST_S)               AND
                 (SERVINTE.DTSERVINTE = P_DTSERVINTE)            AND
                 (SERVINTE.NRSEQUSERV <> V_NRSEQUSERV)           AND
                 (SERVINTE.CDSERVFILI = C_PRESCRICAO.CDSERVFILI);
            END IF;
         END IF;
      END IF;
   END LOOP;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('CALCULA_PRESCRICAO','4.11.034'); END;
/

