/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOTRANSP                                               */
/* Tabela : TIPOTRANSP                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOTRANSP' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOTRANSP
GO

CREATE TRIGGER DTULTATU_TIPOTRANSP
ON TIPOTRANSP
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOTRANSP', null, 'CDTIPTRANS='+ CDTIPTRANS+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOTRANSP
      SET DTULTATUTPTR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(TIPOTRANSP.CDTIPTRANS,0) = ISNULL(INSERTED.CDTIPTRANS,0)) AND
            (ISNULL(TIPOTRANSP.NMTIPTRANS,0) = ISNULL(INSERTED.NMTIPTRANS,0));
   END;
END;
GO

