<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class EsoEnviocadastros extends \Doctrine\ORM\EntityRepository {
    
    public function getEnviosPorNomeEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'        => $nrorg,
                'P_NMEVENTO'     => $nmevento,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRTPAMBIENTE' => $nrtpambiente,
                'P_IDATIVO'      => $idativo,
                'P_NRCHAVE'      => $nrchave,
                'P_NRTABELA'     => $nrtabela,
                'P_IDOPERACAO'   => $idoperacao,
                'P_NRENVIOEXCL'  => $nrenvioexcl
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                     WHERE EC.NRORG = :P_NRORG
                       AND EV.NMEVENTO = :P_NMEVENTO
                       AND EC.NRESTRUTURAM = :P_NRESTRUTURAM
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRCHAVE = :P_NRCHAVE OR :P_NRCHAVE IS NULL)
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }
        
    public function getEnviosPorNomeEventoChave($nrorg, $nmevento, $nrchave, $nrtpambiente, $idativo = 'S', $nrestruturam = null, $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'        => $nrorg,
                'P_NMEVENTO'     => $nmevento,
                'P_NRESTRUTURAM' => $nrestruturam,
                'P_NRTPAMBIENTE' => $nrtpambiente,
                'P_IDATIVO'      => $idativo,
                'P_NRCHAVE'      => $nrchave,
                'P_NRTABELA'     => $nrtabela,
                'P_IDOPERACAO'   => $idoperacao,
                'P_NRENVIOEXCL'  => $nrenvioexcl
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                     WHERE EC.NRORG = :P_NRORG
                       AND INSTR(','||:P_NMEVENTO||',', ','||EV.NMEVENTO||',') > 0 
                       AND EC.NRCHAVE = :P_NRCHAVE
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL)
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
     public function getEnviosPorNomeEventoChaveCnpj($nrorg, $nmevento, $nrchave, $nrtpambiente, $cdcnpjestrut, $dtmescompetenc, $idativo = 'S',  $nrtabela = null, $idoperacao = null, $nrenvioexcl = null) {
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'P_NRORG'          => $nrorg,
                'P_NMEVENTO'       => $nmevento,
                'P_CDCNPJESTRUT'   => $cdcnpjestrut,
                'P_NRTPAMBIENTE'   => $nrtpambiente,
                'P_IDATIVO'        => $idativo,
                'P_NRCHAVE'        => $nrchave,
                'P_NRTABELA'       => $nrtabela,
                'P_IDOPERACAO'     => $idoperacao,
                'P_NRENVIOEXCL'    => $nrenvioexcl,
                'P_DTMESCOMPETENC' => $dtmescompetenc
            );
            $sql = "SELECT EC.*
                      FROM ESO_ENVIOCADASTROS EC
                      JOIN ESO_EVENTO EV ON EV.NREVENTO = EC.NREVENTO
                      JOIN ESTRUTURAH EH ON EH.NRESTRUTURAM = EC.NRESTRUTURAM
                                         AND EH.NRORG = EC.NRORG
                                         AND SUBSTR(EH.CDCNPJESTRUT,1,8) = SUBSTR(:P_CDCNPJESTRUT,1,8)
                                         AND EH.DTMESCOMPETENC = (SELECT MAX(EHH.DTMESCOMPETENC)
                                                                    FROM ESTRUTURAH EHH
                                                                   WHERE EHH.NRORG = EH.NRORG
                                                                     AND EHH.NRESTRUTURAM = EH.NRESTRUTURAM
                                                                     AND EHH.DTMESCOMPETENC <= :P_DTMESCOMPETENC)
                     WHERE EC.NRORG = :P_NRORG
                       AND INSTR(','||:P_NMEVENTO||',', ','||EV.NMEVENTO||',') > 0 
                       AND EC.NRCHAVE = :P_NRCHAVE
                       AND EC.NRTPAMBIENTE = :P_NRTPAMBIENTE
                       AND EC.IDATIVO = :P_IDATIVO
                       AND EC.NRENVIOEXCL IS NULL
                       AND (EC.NRTABELA = :P_NRTABELA OR :P_NRTABELA IS NULL)
                       AND ((:P_NRENVIOEXCL = 'S' AND EC.NRENVIOEXCL IS NOT NULL) OR (:P_NRENVIOEXCL = 'N' AND EC.NRENVIOEXCL IS NULL) OR :P_NRENVIOEXCL IS NULL)
                       AND (EC.IDOPERACAO = :P_IDOPERACAO OR :P_IDOPERACAO IS NULL)";
           
            return $db->fetchAssoc($sql, $params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function getEnviosCadastrosEvento($nrorg, $nmevento, $nrestruturam, $nrtpambiente, $idativo = 'S', $nrchave = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            
            $esoEnviocadastros = Repositories::ESO_ENVIOCADASTROS;
            $esoEvento = Repositories::ESO_EVENTO;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'nrestruturam' => $nrestruturam,
                'nrtpambiente' => $nrtpambiente,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'nrtabela' => $nrtabela,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT ec
                      FROM $esoEnviocadastros ec
                      JOIN $esoEvento ev WITH ev.nrevento = ec.nrevento
                     WHERE ec.nrorg = :nrorg
                       AND ev.nmevento = :nmevento
                       AND (ec.nrestruturam = :nrestruturam OR (ec.nrestruturam <> :nrestruturam  AND ev.nmevento IN ('S-2205','S-2206','S-2306'))) 
                       AND ec.nrtpambiente = :nrtpambiente
                       AND ec.idativo = :idativo
                       AND (ec.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (ec.nrtabela = :nrtabela OR :nrtabela IS NULL)
                       AND ((:nrenvioexcl = 'S' AND ec.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND ec.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (ec.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }

    public function getEnviosCadastrosCnpjEvento($nrorg, $nmevento, $cnpjempregador, $nrtpambiente, $idativo = 'S', $nrchave = null, $dthistorico = null, $nrtabela = null, $idoperacao = array(), $nrenvioexcl=null) {
        try{
            
            $esoEnviocadastros = Repositories::ESO_ENVIOCADASTROS;
            $esoEvento = Repositories::ESO_EVENTO;
            $estruturah = Repositories::ESTRUTURAH;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nmevento' => $nmevento,
                'cnpjempregador' => $cnpjempregador,
                'dtmescompetenc' => \HCM\Util\FPA::getDtCompetencia(),
                'nrtpambiente' => $nrtpambiente,
                'idativo' => $idativo,
                'nrchave' => $nrchave,
                'dthistorico' => $dthistorico,
                'nrtabela' => $nrtabela,
                'nrenvioexcl' => $nrenvioexcl,
            );
            $sql = "SELECT ec
                      FROM $esoEnviocadastros ec
                      JOIN $esoEvento ev WITH ev.nrevento = ec.nrevento
                      JOIN $estruturah eh WITH eh.nrestruturam = ec.nrestruturam
                                           AND eh.nrorg = ec.nrorg
                                           AND SUBSTRING(eh.cdcnpjestrut,1,8) = SUBSTRING(:cnpjempregador,1,8)
                                           AND eh.dtmescompetenc = (SELECT max(ehh.dtmescompetenc)
                                                                      FROM $estruturah ehh
                                                                     WHERE ehh.nrorg = eh.nrorg
                                                                       AND ehh.nrestruturam = eh.nrestruturam
                                                                       AND ehh.dtmescompetenc <= :dtmescompetenc)
                     WHERE ec.nrorg = :nrorg
                       AND ev.nmevento = :nmevento
                       AND ec.nrtpambiente = :nrtpambiente
                       AND ec.idativo = :idativo
                       AND (ec.nrchave = :nrchave OR :nrchave IS NULL)
                       AND (ec.dtmescompetenc = :dthistorico OR :dthistorico IS NULL)
                       AND (ec.nrtabela = :nrtabela OR :nrtabela IS NULL)
                       AND ((:nrenvioexcl = 'S' AND ec.nrenvioexcl IS NOT NULL) OR (:nrenvioexcl = 'N' AND ec.nrenvioexcl IS NULL) OR :nrenvioexcl IS NULL)";
            
            if (!empty($idoperacao)) {
                $sql .= " AND (ec.idoperacao IN ('".implode("','",$idoperacao)."'))";
            }
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getEnvioAdmissaoVinculo($nrorg, $nrtpambiente, $cdcnpjempregador, $nrvinculom, $dtmescompetenc) {
        try{
            $esoEnviocadastros = Repositories::ESO_ENVIOCADASTROS;
            $esoEvento = Repositories::ESO_EVENTO;
            $estruturah = Repositories::ESTRUTURAH;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nrtpambiente' => $nrtpambiente,
                'cdcnpjempregador' => $cdcnpjempregador,
                'nrvinculom' => $nrvinculom,
                'dtmescompetenc' => $dtmescompetenc,
            );
            $sql = "SELECT envio
                      FROM $esoEnviocadastros envio
                      JOIN $esoEvento ev WITH ev.nrevento = envio.nrevento
                                          AND ev.nmevento IN ('S-2190','S-2200','S-2300')
                      JOIN $estruturah evh WITH evh.nrorg = envio.nrorg
                                            AND evh.nrestruturam = envio.nrestruturam
                                            AND SUBSTRING(evh.cdcnpjestrut,1,8) = SUBSTRING(:cdcnpjempregador,1,8)
                                            AND evh.dtmescompetenc = (SELECT MAX(h1.dtmescompetenc) FROM $estruturah h1
                                                                       WHERE h1.nrorg = evh.nrorg
                                                                         AND h1.nrestruturam = evh.nrestruturam
                                                                         AND h1.dtmescompetenc <= :dtmescompetenc)
                     WHERE envio.nrorg = :nrorg
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.nrchave = :nrvinculom
                       AND envio.idativo = 'S'
                       AND envio.nrenvioexcl IS NULL
                     ORDER BY envio.dtmescompetenc DESC";
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function getEnvioRescisaoVinculo($nrorg, $nrtpambiente, $cdcnpjempregador, $nrvinculom, $dtmescompetenc) {
        try{
            $esoEnviocadastros = Repositories::ESO_ENVIOCADASTROS;
            $esoEvento = Repositories::ESO_EVENTO;
            $estruturah = Repositories::ESTRUTURAH;
            
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $params = array(
                'nrorg' => $nrorg,
                'nrtpambiente' => $nrtpambiente,
                'cdcnpjempregador' => $cdcnpjempregador,
                'nrvinculom' => $nrvinculom,
                'dtmescompetenc' => $dtmescompetenc,
            );
            $sql = "SELECT envio
                      FROM $esoEnviocadastros envio
                      JOIN $esoEvento ev WITH ev.nrevento = envio.nrevento
                                          AND ev.nmevento IN ('S-2299','S-2399')
                      JOIN $estruturah evh WITH evh.nrorg = envio.nrorg
                                            AND evh.nrestruturam = envio.nrestruturam
                                            AND SUBSTRING(evh.cdcnpjestrut,1,8) = SUBSTRING(:cdcnpjempregador,1,8)
                                            AND evh.dtmescompetenc = (SELECT MAX(h1.dtmescompetenc) FROM $estruturah h1
                                                                       WHERE h1.nrorg = evh.nrorg
                                                                         AND h1.nrestruturam = evh.nrestruturam
                                                                         AND h1.dtmescompetenc <= :dtmescompetenc)
                     WHERE envio.nrorg = :nrorg
                       AND envio.nrtpambiente = :nrtpambiente
                       AND envio.nrchave = :nrvinculom
                       AND envio.idativo = 'S'
                       AND envio.nrenvioexcl IS NULL
                     ORDER BY envio.dtmescompetenc DESC";
           
            return $this->getEntityManager()->createQuery($sql)->execute($params);
        } catch (Exception $e) {
            throw $e;
        }
    }
}